;;----------------------------------------
;; TENTO PROGRAM DEMONSTRUJE PREHRAVANI
;; HUDEBNI SKLADBY (MOZART) NA CTYRECH
;; TONOVYCH GENERATORECH
;; - tentokrat je pridan komentar
;;----------------------------------------
	LIST	P = 16F877, R = DEC
	include	p16f877.inc

	__CONFIG	H'3F72'

;--------------------------------------

	include	tab_util.inc
	include	zapisnot.inc
	include	delky.inc
	include	adr_save.inc

; !!! DALE JSOU VYZADOVANY SOUBORY :
;
; !		ampldata.inc
; !		tony.inc
; !		casy.inc
; !		dozvuky.inc
; !		hlasit.inc
; !		mozart.inc

FAZE	EQU	D'0'
AKTIVNI	EQU	D'1'
DOZVUK	EQU	D'2'

OFFRAM	EQU	H'20'	; zacatek volne pameti "RAM"
TEMPRAM	EQU	H'70'	; posledni blok pameti (16 bytu)
			; - je zrcadlen do vsech pametovych bank 

	CBLOCK	OFFRAM
	PERIOD1:2		; pracovni "buffer" pro periodu kanalu 1
	PERIOD1_:2	; aktualni perioda frekvence kanalu 1
	AMPLIT1:2		; aktualni amplituda kanalu 1
	DOZVUK1:2		; dozvuk kanalu 1
	COUNTER1:1	; pomocny citac pro kanal 1
	ZSTATUS1:1	; stavova promenna kanalu 1
	ZVUK1:1		; vystupni zvukovy vzorek kanalu 1

	PERIOD2:2		; totez pro kanal 2...
	PERIOD2_:2
	AMPLIT2:2
	DOZVUK2:2
	COUNTER2:1
	ZSTATUS2:1
	ZVUK2:1

	PERIOD3:2		; pro kanal 3...
	PERIOD3_:2
	AMPLIT3:2
	DOZVUK3:2
	COUNTER3:1
	ZSTATUS3:1
	ZVUK3:1

	PERIOD4:2		; pro kanal 4...
	PERIOD4_:2
	AMPLIT4:2
	DOZVUK4:2
	COUNTER4:1
	ZSTATUS4:1
	ZVUK4:1

	ZVUK:1		; vysledny zvuk (soucet vzorku)

	TEMP:2		; pomocna promena
	DELAY:3		; casovac pro hudbu
	EADR_TEMP:2	; pro uschovu flash adresy
	AKTIV:1		; indikatory kanalu
	NEAKTIV:1		; - || -
	TON_:1		; index tonu
	HLASIT_:1		; index hlasitosti
	DOZVUK_:1		; index dozvuku

	WTABTEMP:1	; pomocna promenna
	ENDC

	CBLOCK	TEMPRAM	; zalozni registry, ktere
	W_TEMP:1		; jsou nezavisle na zvolene
	ST_TEMP:1		; pametove bance !!!
	ENDC



;--------------------------------------

	ORG      0
	NOP
	NOP
	NOP
	GOTO     START

	ORG	4
	MOVWF	W_TEMP	; zaloha registru W,STATUS a FSR
	MOVF	STATUS,W
	MOVWF	ST_TEMP
	banksel	0

	BTFSS	PIR1,TMR2IF ; preruseni pomoci TMR2
	GOTO	INT_END
	DECFSZ	DELAY+0,F	; dekrementace 16bitoveho casovace
	GOTO	ZVUK___
	DECFSZ	DELAY+1,F
	GOTO	ZVUK___
	BSF	DELAY+2,0	; zde se nachazi indikator podteceni

ZVUK___	RRF	ZVUK,F	; zde se provadi kopirovani zvuku do PWM kanalu
	BCF	CCP1CON,CCP1Y
	BTFSC	STATUS,C
	BSF	CCP1CON,CCP1Y
	RRF	ZVUK,W
	BCF	CCP1CON,CCP1X
	BTFSC	STATUS,C
	BSF	CCP1CON,CCP1X
	ANDLW	B'00111111'
	MOVWF	CCPR1L
	BCF	PIR1,TMR2IF

	; zde se jiz zpracovavaji jednotlive kanaly:	
	; (viz. predchozi lekce Miniskoly)
	BTFSS	ZSTATUS1,AKTIVNI	; kanal 1
	GOTO	POZVUK1
	DECF	PERIOD1+1,F
	INCF	PERIOD1+1,W
	BTFSS	STATUS,Z
	GOTO	PO_PER1
	MOVF	PERIOD1_+0,W
	ADDWF	PERIOD1+0,F
	MOVF	PERIOD1_+1,W
	BTFSC	STATUS,C
	INCFSZ	PERIOD1_+1,W
	ADDWF	PERIOD1+1,F
	MOVLW	B'00000001'
	XORWF	ZSTATUS1,F
PO_PER1	MOVF	AMPLIT1+1,W
	BTFSS	ZSTATUS1,FAZE
	MOVLW	D'0'
	MOVWF	ZVUK1
	DECFSZ	COUNTER1,F
	GOTO	POZVUK1
	MOVLW	D'64'
	MOVWF	COUNTER1
	BTFSS	ZSTATUS1,DOZVUK
	GOTO	POZVUK1
	MOVF	DOZVUK1+0,W
	SUBWF	AMPLIT1+0,F
	MOVF	DOZVUK1+1,W
	BTFSS	STATUS,C
	INCFSZ	DOZVUK1+1,W
	SUBWF	AMPLIT1+1,F
	BTFSS	STATUS,C
	BCF	ZSTATUS1,AKTIVNI
POZVUK1
	BTFSS	ZSTATUS2,AKTIVNI	; kanal 2
	GOTO	POZVUK2
	DECF	PERIOD2+1,F
	INCF	PERIOD2+1,W
	BTFSS	STATUS,Z
	GOTO	PO_PER2
	MOVF	PERIOD2_+0,W
	ADDWF	PERIOD2+0,F
	MOVF	PERIOD2_+1,W
	BTFSC	STATUS,C
	INCFSZ	PERIOD2_+1,W
	ADDWF	PERIOD2+1,F
	MOVLW	B'00000001'
	XORWF	ZSTATUS2,F
PO_PER2	MOVF	AMPLIT2+1,W
	BTFSS	ZSTATUS2,FAZE
	MOVLW	D'0'
	MOVWF	ZVUK2
	DECFSZ	COUNTER2,F
	GOTO	POZVUK2
	MOVLW	D'64'
	MOVWF	COUNTER2
	BTFSS	ZSTATUS2,DOZVUK
	GOTO	POZVUK2
	MOVF	DOZVUK2+0,W
	SUBWF	AMPLIT2+0,F
	MOVF	DOZVUK2+1,W
	BTFSS	STATUS,C
	INCFSZ	DOZVUK2+1,W
	SUBWF	AMPLIT2+1,F
	BTFSS	STATUS,C
	BCF	ZSTATUS2,AKTIVNI
POZVUK2
	BTFSS	ZSTATUS3,AKTIVNI	; kanal 2
	GOTO	POZVUK3
	DECF	PERIOD3+1,F
	INCF	PERIOD3+1,W
	BTFSS	STATUS,Z
	GOTO	PO_PER3
	MOVF	PERIOD3_+0,W
	ADDWF	PERIOD3+0,F
	MOVF	PERIOD3_+1,W
	BTFSC	STATUS,C
	INCFSZ	PERIOD3_+1,W
	ADDWF	PERIOD3+1,F
	MOVLW	B'00000001'
	XORWF	ZSTATUS3,F
PO_PER3	MOVF	AMPLIT3+1,W
	BTFSS	ZSTATUS3,FAZE
	MOVLW	D'0'
	MOVWF	ZVUK3
	DECFSZ	COUNTER3,F
	GOTO	POZVUK3
	MOVLW	D'64'
	MOVWF	COUNTER3
	BTFSS	ZSTATUS3,DOZVUK
	GOTO	POZVUK3
	MOVF	DOZVUK3+0,W
	SUBWF	AMPLIT3+0,F
	MOVF	DOZVUK3+1,W
	BTFSS	STATUS,C
	INCFSZ	DOZVUK3+1,W
	SUBWF	AMPLIT3+1,F
	BTFSS	STATUS,C
	BCF	ZSTATUS3,AKTIVNI
POZVUK3
	BTFSS	ZSTATUS4,AKTIVNI	; kanal 2
	GOTO	POZVUK4
	DECF	PERIOD4+1,F
	INCF	PERIOD4+1,W
	BTFSS	STATUS,Z
	GOTO	PO_PER4
	MOVF	PERIOD4_+0,W
	ADDWF	PERIOD4+0,F
	MOVF	PERIOD4_+1,W
	BTFSC	STATUS,C
	INCFSZ	PERIOD4_+1,W
	ADDWF	PERIOD4+1,F
	MOVLW	B'00000001'
	XORWF	ZSTATUS4,F
PO_PER4	MOVF	AMPLIT4+1,W
	BTFSS	ZSTATUS4,FAZE
	MOVLW	D'0'
	MOVWF	ZVUK4
	DECFSZ	COUNTER4,F
	GOTO	POZVUK4
	MOVLW	D'64'
	MOVWF	COUNTER4
	BTFSS	ZSTATUS4,DOZVUK
	GOTO	POZVUK4
	MOVF	DOZVUK4+0,W
	SUBWF	AMPLIT4+0,F
	MOVF	DOZVUK4+1,W
	BTFSS	STATUS,C
	INCFSZ	DOZVUK4+1,W
	SUBWF	AMPLIT4+1,F
	BTFSS	STATUS,C
	BCF	ZSTATUS4,AKTIVNI
POZVUK4

	MOVF	ZVUK1,W	; ZVUK-1,2,3,4 se scitaji do konecneho zvuku
	CALL	AMPLITUDA	; (viz. minula lekce)
	MOVWF	ZVUK
	MOVF	ZVUK2,W
	CALL	AMPLITUDA
	ADDWF	ZVUK,F
	MOVLW	D'255'
	BTFSC	STATUS,C
	MOVWF	ZVUK
	MOVF	ZVUK3,W
	CALL	AMPLITUDA
	ADDWF	ZVUK,F
	MOVLW	D'255'
	BTFSC	STATUS,C
	MOVWF	ZVUK
	MOVF	ZVUK4,W
	CALL	AMPLITUDA
	ADDWF	ZVUK,F
	MOVLW	D'255'
	BTFSC	STATUS,C
	MOVWF	ZVUK

INT_END	MOVF	ST_TEMP,W
	MOVWF	STATUS
	SWAPF	W_TEMP,F
	SWAPF	W_TEMP,W
	RETFIE 

START	
	banksel	TRISC	; nastaveni casovace TMR2 a PWM vystupu
	BCF	TRISC,2
	banksel	T2CON
	MOVLW	B'00011100'
	MOVWF	T2CON
	banksel	PR2
	MOVLW	D'63'
	MOVWF	PR2
	banksel	0
	CLRF	TMR2
	CLRF	CCPR1L
	MOVLW	B'00001100'
	MOVWF	CCP1CON

	CLRF	ZVUK1	; resetovani vsech kanalu
	CLRF	ZVUK2
	CLRF	ZVUK3
	CLRF	ZVUK4
	BCF	ZSTATUS1,AKTIVNI
	BCF	ZSTATUS2,AKTIVNI
	BCF	ZSTATUS3,AKTIVNI
	BCF	ZSTATUS4,AKTIVNI
	BSF	ZSTATUS1,DOZVUK
	BSF	ZSTATUS2,DOZVUK
	BSF	ZSTATUS3,DOZVUK
	BSF	ZSTATUS4,DOZVUK

	banksel	PIE1	; preruseni od TMR2
	BSF	PIE1,TMR2IE
	banksel	0
	BSF	INTCON,PEIE
	BSF	INTCON,GIE

	MOVLW	D'255'	; resetovani casovace skladby
	MOVWF	DELAY+0
	MOVWF	DELAY+1

	MOVLW	D'0'	; vybereme skadbu s indexem 0 (jina tu stejne neni)
	TABFIND	HUDBY
	BSF	DELAY+2,0	; tvarime se, ze casovac skladby jiz podtekl
LOOP	BTFSS	DELAY+2,0	; cekame na podteceni casovace skladby
	GOTO	$ - 1
	BCF	DELAY+2,0	; mazeme priznak podteceni
	CALL	CTI_CAS	; precteme nasledujici casovani (14 bitu - index casovani + priznaky kanalu)
	MOVF	TEMP+1,W	; v TEMP je nyni nastaveni casovace DELAY
	IORWF	TEMP+0,W
	BTFSC	STATUS,Z
	GOTO	MUS_END	; ...pokud je rovno nule, hudba skoncila
	BCF	INTCON,GIE ; kriticka sekce - nastavujeme DELAY
	BTFSC	INTCON,GIE
	GOTO	$ - 2
	MOVF	TEMP+0,W
	MOVWF	DELAY+0
	MOVF	TEMP+1,W
	MOVWF	DELAY+1
	BSF	INTCON,GIE

	; nyni nastavujeme prvni kanal
	BTFSS	NEAKTIV,0	; pokud je nastaven indikator vypnuti kanalu,...
	GOTO	$ + 3
	BCF	ZSTATUS1,AKTIVNI	; ...kanal se vypne
	CLRF	ZVUK1
	BTFSS	AKTIV,0	; pokud je nastaven indikator nastaveni kanalu,...
	GOTO	DALSI_1
	CALL	CTI_TON	; ...precteme toto nastaveni (14 bitu - TON_, HLASIT_, DOZVUK_)
	EADR_PUSH EADR_TEMP	; zalohujeme flash adresu
	MOVF	TON_,W	; vybereme ton z tabulky
	CALL	GETTON
	MOVF	TEMP+0,W	; ...a podle nej nastavime periodu frekvence kanalu
	MOVWF	PERIOD1_+0
	MOVF	TEMP+1,W
	MOVWF	PERIOD1_+1
	MOVF	HLASIT_,W	; vybereme hlasitost z tabulky
	CALL	GETHLASIT
	MOVF	TEMP+0,W
	MOVWF	AMPLIT1+1	; ...a nastavime podle toho AMPLIT1_
	MOVLW	D'255'
	MOVWF	AMPLIT1+0
	MOVF	DOZVUK_,W	; vybereme dozvuk z tabulky
	CALL	GETDOZVUK
	MOVF	TEMP+0,W
	MOVWF	DOZVUK1+0	; ...a nastavime
	MOVF	TEMP+1,W
	MOVWF	DOZVUK1+1
	BSF	ZSTATUS1,AKTIVNI ; zaktivujeme kanal (1)
	EADR_POP	EADR_TEMP	; obnovime zalohu flash adresy

DALSI_1	BTFSS	NEAKTIV,1	; totez provedeme pro kanaly 2,3,4
	GOTO	$ + 3
	BCF	ZSTATUS2,AKTIVNI
	CLRF	ZVUK2
	BTFSS	AKTIV,1
	GOTO	DALSI_2
	CALL	CTI_TON
	EADR_PUSH EADR_TEMP
	MOVF	TON_,W
	CALL	GETTON
	MOVF	TEMP+0,W
	MOVWF	PERIOD2_+0
	MOVF	TEMP+1,W
	MOVWF	PERIOD2_+1
	MOVF	HLASIT_,W
	CALL	GETHLASIT
	MOVF	TEMP+0,W
	MOVWF	AMPLIT2+1
	MOVLW	D'255'
	MOVWF	AMPLIT2+0
	MOVF	DOZVUK_,W
	CALL	GETDOZVUK
	MOVF	TEMP+0,W
	MOVWF	DOZVUK2+0
	MOVF	TEMP+1,W
	MOVWF	DOZVUK2+1
	BSF	ZSTATUS2,AKTIVNI
	EADR_POP	EADR_TEMP
DALSI_2	BTFSS	NEAKTIV,2
	GOTO	$ + 3
	BCF	ZSTATUS3,AKTIVNI
	CLRF	ZVUK3
	BTFSS	AKTIV,2
	GOTO	DALSI_3
	CALL	CTI_TON
	EADR_PUSH EADR_TEMP
	MOVF	TON_,W
	CALL	GETTON
	MOVF	TEMP+0,W
	MOVWF	PERIOD3_+0
	MOVF	TEMP+1,W
	MOVWF	PERIOD3_+1
	MOVF	HLASIT_,W
	CALL	GETHLASIT
	MOVF	TEMP+0,W
	MOVWF	AMPLIT3+1
	MOVLW	D'255'
	MOVWF	AMPLIT3+0
	MOVF	DOZVUK_,W
	CALL	GETDOZVUK
	MOVF	TEMP+0,W
	MOVWF	DOZVUK3+0
	MOVF	TEMP+1,W
	MOVWF	DOZVUK3+1
	BSF	ZSTATUS3,AKTIVNI
	EADR_POP	EADR_TEMP
DALSI_3	BTFSS	NEAKTIV,3
	GOTO	$ + 3
	BCF	ZSTATUS4,AKTIVNI
	CLRF	ZVUK4
	BTFSS	AKTIV,3
	GOTO	DALSI_4
	CALL	CTI_TON
	EADR_PUSH EADR_TEMP
	MOVF	TON_,W
	CALL	GETTON
	MOVF	TEMP+0,W
	MOVWF	PERIOD4_+0
	MOVF	TEMP+1,W
	MOVWF	PERIOD4_+1
	MOVF	HLASIT_,W
	CALL	GETHLASIT
	MOVF	TEMP+0,W
	MOVWF	AMPLIT4+1
	MOVLW	D'255'
	MOVWF	AMPLIT4+0
	MOVF	DOZVUK_,W
	CALL	GETDOZVUK
	MOVF	TEMP+0,W
	MOVWF	DOZVUK4+0
	MOVF	TEMP+1,W
	MOVWF	DOZVUK4+1
	BSF	ZSTATUS4,AKTIVNI
	EADR_POP	EADR_TEMP
DALSI_4	GOTO	LOOP	; opakovani cyklu prehravani skladby

MUS_END	GOTO	$	; konec programu


CTI_CAS	NEXTREAD	; precteme nasledujici zaznam ve flash pameti
	banksel	EEDATA	; predpoklada se informace o casovani
	MOVF	EEDATA,W
	banksel	AKTIV	; extrahujeme indikatory nastaveni kanalu
	ANDLW	B'00001111'
	MOVWF	AKTIV
	banksel	EEDATA
	SWAPF	EEDATA,W
	banksel	NEAKTIV	; extrahujeme indikatory vypnuti kanalu
	ANDLW	B'00001111'
	MOVWF	NEAKTIV
	EADR_PUSH	EADR_TEMP	; zaloha aktualni flash adresy
	banksel	EEDATH
	MOVF	EEDATH,W	; podle indexu vybereme z tabulky 16bitovou casovaci prodlevu
	CALL	GETCAS
	EADR_POP	EADR_TEMP	; obnoveni flash adresy ze zalohy
	RETURN

CTI_TON	NEXTREAD	; precteme nasledujici zaznam ve flash pameti
	banksel	EEDATA	; predpoklada se informace o nastaveni generatoru
	MOVF	EEDATA,W
	banksel	TON_
	MOVWF	TON_	; extrahuje se index do tabulky frekvenci tonu
	banksel	EEDATH
	MOVF	EEDATH,W
	banksel	HLASIT_
	ANDLW	B'00000111'
	MOVWF	HLASIT_	; extrahuje se index do tabulky hlasitosti
	banksel	EEDATH
	RRF	EEDATH,F
	RRF	EEDATH,F
	RRF	EEDATH,W
	banksel	DOZVUK_
	ANDLW	B'00000111'
	MOVWF	DOZVUK_	; extrahuje se index do tabulky dozvuku
	RETURN

CTENI	
	banksel	EECON1		; cteni z FLASH
	BSF	EECON1,EEPGD
	BSF	EECON1,RD
	NOP
	NOP
	BCF	STATUS,C
	banksel	EEDATA
	RLF	EEDATA,W	; pomocny posun doleva (zdvojnasobeni)
	banksel	TEMP+0
	MOVWF	TEMP+0
	banksel	EEDATH
	RLF	EEDATH,W
	banksel	TEMP+1
	MOVWF	TEMP+1	; vysledek je v TEMP
	RETURN

GETCAS	; nastavi ukazatel do tabulky casovych prodlev
	banksel	EECON1	; podle indexu z W
	BTFSC	EECON1,WR
	GOTO	$ - 1
	banksel	EEADR		; TONY + W -> (EEADRH:EEADRL)
	ADDLW	CASY % D'256'
	MOVWF	EEADR
	MOVLW	CASY / D'256'
	BTFSC	STATUS,C
	ADDLW	D'1'
	MOVWF	EEADRH
	CALL	CTENI	; precteme hodnotu znasobenou 2
	RLF	TEMP+0,F	; jeste ji jednou znasobime
	RLF	TEMP+1,F	; - tak dasahneme i obsazeni nejvyssiho bitu
	RETURN

GETTON	; obdobne jako GETCAS
	banksel	EECON1
	BTFSC	EECON1,WR
	GOTO	$ - 1
	banksel	EEADR		; TONY + W -> (EEADRH:EEADRL)
	ADDLW	TONY % D'256'
	MOVWF	EEADR
	MOVLW	TONY / D'256'
	BTFSC	STATUS,C
	ADDLW	D'1'
	MOVWF	EEADRH
	CALL	CTENI
	RLF	TEMP+0,F
	RLF	TEMP+1,F
	RETURN

GETDOZVUK	; podobne jako GETCAS, ale...
	banksel	EECON1
	BTFSC	EECON1,WR
	GOTO	$ - 1
	banksel	EEADR		; DOZVUKY + W -> (EEADRH:EEADRL)
	ADDLW	DOZVUKY % D'256'
	MOVWF	EEADR
	MOVLW	DOZVUKY / D'256'
	BTFSC	STATUS,C
	ADDLW	D'1'
	MOVWF	EEADRH
	CALL	CTENI
	RRF	TEMP+1,F	; ..nechceme vynasobeni 2 (provedeme opacny posun)
	RRF	TEMP+0,F
	RETURN

GETHLASIT	; podobne jako GETDOZVUK
	banksel	EECON1
	BTFSC	EECON1,WR
	GOTO	$ - 1
	banksel	EEADR		; DOZVUKY + W -> (EEADRH:EEADRL)
	ADDLW	HLASITOST % D'256'
	MOVWF	EEADR
	MOVLW	HLASITOST / D'256'
	BTFSC	STATUS,C
	ADDLW	D'1'
	MOVWF	EEADRH
	CALL	CTENI
	RRF	TEMP+1,F
	RRF	TEMP+0,F
	RETURN

;---------------------------------------
; amplitudy dozvuku

AMPLITUDA	MOVWF	WTABTEMP	; toto bylo vysvetleno jiz drive
	MOVLW	AMPLDATA / H'100'
	MOVWF	PCLATH
	MOVLW	AMPLDATA % H'100'
	ADDWF	WTABTEMP,W
	BTFSC	STATUS,C
	INCF	PCLATH,F
	MOVWF	PCL
AMPLDATA
	include	ampldata.inc

;---------------------------------------
; periody vybranych tonu
TONY	
	include	tony.inc

;---------------------------------------
; delky not (respektive casovani znacek)
CASY
	include	casy.inc

;---------------------------------------
; preddefinovane delky dozvuku
DOZVUKY
	include	dozvuky.inc

;---------------------------------------
; preddefinovane hlasitosti
HLASITOST	
	include	hlasit.inc

;--------------------------------------
; SKLADBY (funguje to tu stejne jako "zobrazovaci skripty")

HUDBY	DATA	MOZART	; rozcesti bez moznosti volby
	; zde by mohlo byt napriklad "DATA	DVORAK" ...
	; ...a tak dale

MOZART	
	include	mozart.inc
; zde by mohlo byt napriklad
; DVORAK	
;	include	dvorak.inc

	END
