;----------------------------------------
; !! TENTO PROGRAM NIC NEVYKONAVA !!
; - pouze uvadi priklad realizace
;   systemu preruseni s dvemi prioritami
;----------------------------------------

	LIST	P = 16F877, R = DEC
	include	p16f877.inc

	__CONFIG	H'3F72'

;----------------------------------------


OFFRAM	EQU	H'20'	; zacatek volne pameti "RAM"
TEMPRAM	EQU	H'70'	; posledni blok pameti (16 bytu)
			; - je zrcadlen do vsech pametovych bank 

	CBLOCK	OFFRAM
	CITAC:1	; uzivatelsky registr
	ENDC

	CBLOCK	TEMPRAM	; zalozni registry
	W_TEMP1:1		; - pro nizkou prioritu
	ST_TEMP1:1
	W_TEMP2:1		; - pro vysokou prioritu
	ST_TEMP2:1
	INTPRIOR_:1	; - registr priority preruseni musi byt take
			;   imuni vuci nastaveni pametove banky
	ENDC

#DEFINE	INTPRIOR	INTPRIOR_,0 ; definuji indikacni bit priority

MASKA	EQU	B'11011111' ; maska preruseni pro INTCON (nuluje T0IE)

;---------------------------------------

	ORG	0
	GOTO	START

	ORG	H'04'
	; VSTUP DO OBLUHY PRERUSENI
	BTFSC	INTPRIOR	; zde je rozcesti mezi nizkou a vysokou prioritou
	GOTO	HINTPROC
	BSF	INTPRIOR	; dalsi preruseni musi byt s vysokou prioritpu

	; PRERUSENI S "NIZKOU" PRIORITOU
	MOVWF	W_TEMP1	; klasicka zaloha registru
	MOVF	STATUS,W
	MOVWF	ST_TEMP1
	banksel	0
	MOVLW	MASKA	; maskovani preruseni s nizkou prioritou
	ANDWF	INTCON,F
	BSF	INTCON,GIE ; aktivace systemu preruseni
			 ; - od ted muze preruseni znovu nastat!

	BTFSS	INTCON,T0IF ; probiha "zdrzovaci smycka"
	GOTO	NEXT3	  ; - jen kvuli demonstraci
	BCF	INTCON,T0IF
OPAKUJ	DECFSZ	CITAC,F
	GOTO	OPAKUJ
NEXT3

	BCF	INTCON,GIE ; deaktivace systemu preruseni
	BTFSC	INTCON,GIE
	GOTO	$ - 2
	MOVLW	~MASKA	; odmaskovani preruseni s nizkou prioritou
	IORWF	INTCON,F
	BCF	INTPRIOR	; od teto chvile se predpoklada preruseni s nizkou prioritou
	MOVF	ST_TEMP1,W ; obnova registru ze zalohy
	MOVWF	STATUS
	SWAPF	W_TEMP1,F
	SWAPF	W_TEMP1,W
	RETFIE

	; PRERUSENI S VYSOKOU PRIORITOU
HINTPROC	MOVWF	W_TEMP2	; druha zaloha registru (protoze jsme provedli...
	MOVF	STATUS,W	; ...preruseni jineho preruseni)
	MOVWF	ST_TEMP2
	banksel	0

	BTFSS	INTCON,INTF ; obsluha dvou zdroju preruseni
	GOTO	NEXT1
	BCF	INTCON,INTF
	NOP
	NOP
NEXT1	BTFSS	PIR1,TMR2IF
	GOTO	NEXT2
	BCF	PIR1,TMR2IF
	NOP
	NOP	
NEXT2

	MOVF	ST_TEMP2,W ; obnova registru z druhe zalohy
	MOVWF	STATUS
	SWAPF	W_TEMP2,F
	SWAPF	W_TEMP2,W
	RETFIE

;-------------------------------------------

START	BCF	INTPRIOR	; predpoklada se nizka priorita preruseni
	BSF	INTCON,PEIE ; preruseni od:
	BSF	INTCON,INTE ; - hrany na RB0
	BSF	INTCON,T0IE ; - preteceni TMR0
	BSF	PIE1,TMR2IE ; - preteceni TMR2
	banksel	OPTION_REG
	MOVLW	B'11010010' ; - hrana: nabezna
	MOVWF	OPTION_REG  ; - preddelicka: 1:4
	MOVLW	D'64'	; - preioda TMR2: 64
	MOVWF	PR2
	banksel	0
	MOVLW	B'00000100' ; - preddelicka TMR2: 1:1
	MOVWF	T2CON	; - postdelicka TMR2: 1:1
	
	CLRF	CITAC

	BSF	INTCON,GIE ; aktivace systemu preruseni

LOOP	GOTO	LOOP
	
	END
