;; TENTO PROGRAM DEMONSTRUJE
;; moznost prehravani hudby
;; na pozadi jineho procesu
;; - neni doplnen komentar
;; - prerusovaci rutina
;;   je napsana tak,
;;   aby setrila zasobnik
;;   navratovych adres!!
;--------------------------------------
;; - libovolnym tlacitkem v radku
;; "1,2,3,A" prepnete do modu
;; zobrazovani tonu
;;
;; - libovolnym tlacitkem v radku
;; "4,5,6,B" prepnete do modu
;; zobrazovani hlasitosti (logarit.)
;--------------------------------------

	LIST	P = 16F877, R = DEC
	include	p16f877.inc

	__CONFIG	H'3F72'

;--------------------------------------

	include	tab_util.inc
	include	zapisnot.inc
	include	noty.inc
	include	div16u.inc
	include	displej0.inc
	include	dskripty.inc
	include	cti_cas.inc
	include	gener.inc
	include	setgen.inc

; !!! DALE JSOU VYZADOVANY SOUBORY :
;
; !		ampldata.inc
; !		tony.inc
; !		casy.inc
; !		dozvuky.inc
; !		hlasit.inc
; !		mozart.inc

FAZE	EQU	D'0'
AKTIVNI	EQU	D'1'
DOZVUK	EQU	D'2'

OFFRAM	EQU	H'20'	; zacatek volne pameti "RAM"
TEMPRAM	EQU	H'70'	; posledni blok pameti (16 bytu)
			; - je zrcadlen do vsech pametovych bank 

#DEFINE	DB4	PORTE,2
#DEFINE	DB5	PORTE,1
#DEFINE	DB6	PORTE,0
#DEFINE	DB7	PORTA,4
#DEFINE	E	PORTB,1
#DEFINE	RW	PORTB,2
#DEFINE	RS	PORTB,3

#DEFINE	KLAVESA1	PORTD,0
#DEFINE	KLAVESA2	PORTD,1


	CBLOCK	OFFRAM
	TML:1	; pro obsluhu displeje
	TMH:1
	DDATA:1

	AA:2	; pro skripty
	BB:2
	CC:2
	VD16U:1
	NUMFORM_:1

	ZSTATUS1:1
	ZVUK1:1
	TON1:1
	PERIOD1_:2
	DOZVUK1:2
	AMPLIT1:2
	PERIOD1:2
	COUNTER1:1

	ZSTATUS2:1
	ZVUK2:1
	TON2:1
	PERIOD2_:2
	DOZVUK2:2
	AMPLIT2:2
	PERIOD2:2
	COUNTER2:1

	ZSTATUS3:1
	ZVUK3:1
	TON3:1
	PERIOD3_:2
	DOZVUK3:2
	AMPLIT3:2
	PERIOD3:2
	COUNTER3:1

	ZSTATUS4:1
	ZVUK4:1
	TON4:1
	PERIOD4_:2
	DOZVUK4:2
	AMPLIT4:2
	PERIOD4:2
	COUNTER4:1

	ZVUK:1

	GCITAC:1
	TEMP:2
	DELAY:3
	EADR_TEMP:2
	AKTIV:1
	NEAKTIV:1
	TON_:1
	HLASIT_:1
	DOZVUK_:1

	WTABTEMP:1

	PLAY:1

	HH1:1
	HH2:1
	HH3:1
	HH4:1
	ENDC

	CBLOCK	OFFRAM +	H'100'
	EEDATAX:1
	EEDATHX:1
	EEADRX:1
	EEADRHX:1
	EEADRY:1
	EEADRHY:1
	ENDC

	CBLOCK	OFFRAM +	H'80'
	POLE:8
	PCOUNT:1
	PTEMP:1
	PCITAC:1
	ENDC

	CBLOCK	TEMPRAM	; zalozni registry, ktere
	W_TEMP:1		; jsou nezavisle na zvolene
	ST_TEMP:1		; pametove bance !!!
	FSR_TEMP:1
	PCL_TEMP:1
	INTVER:1
	W_TEMP2:1
	ST_TEMP2:1
	FSR_TEMP2:1
	ENDC

;--------------------------------------

	ORG      0
	NOP
	NOP
	NOP
	GOTO     START

	ORG	4
	BTFSC	INTVER,0
	GOTO	H_INT

	MOVWF	W_TEMP	; zaloha registru W,STATUS a FSR
	MOVF	STATUS,W
	MOVWF	ST_TEMP
	MOVF	FSR,W
	MOVWF	FSR_TEMP
	banksel	0
	BSF	INTVER,0
	BSF	INTCON,GIE

	BTFSS	PLAY,0
	GOTO	INT_END
	BTFSS	DELAY+2,0
	GOTO	INT_END
	banksel	EEDATA
	MOVF	EEDATA,W
	MOVWF	EEDATAX
	MOVF	EEDATH,W
	MOVWF	EEDATHX
	MOVF	EEADR,W
	MOVWF	EEADRX
	MOVF	EEADRH,W
	MOVWF	EEADRHX

	MOVF	EEADRY,W
	MOVWF	EEADR
	MOVF	EEADRHY,W
	MOVWF	EEADRH
	banksel	0
	GOTO	PLAYCODE
LABELX
	banksel	EEDATA
	MOVF	EEADR,W
	MOVWF	EEADRY
	MOVF	EEADRH,W
	MOVWF	EEADRHY

	MOVF	EEDATAX,W
	MOVWF	EEDATA
	MOVF	EEDATHX,W
	MOVWF	EEDATH
	MOVF	EEADRX,W
	MOVWF	EEADR
	MOVF	EEADRHX,W
	MOVWF	EEADRH
	banksel	0

INT_END	BCF	INTCON,GIE
	BTFSC	INTCON,GIE
	GOTO	$ - 2
	BCF	INTVER,0

	MOVF	FSR_TEMP,W
	MOVWF	FSR
	MOVF	ST_TEMP,W
	MOVWF	STATUS
	SWAPF	W_TEMP,F
	SWAPF	W_TEMP,W
	RETFIE 

H_INT	MOVWF	W_TEMP2	; zaloha registru W,STATUS a FSR
	MOVF	STATUS,W
	MOVWF	ST_TEMP2
	CLRF	PCLATH
	CLRF	STATUS
	BCF	PIR1,TMR2IF

	DECFSZ	DELAY+0,F
	GOTO	ZVUK___
	DECFSZ	DELAY+1,F
	GOTO	ZVUK___
	BSF	DELAY+2,0

ZVUK___	RRF	ZVUK,F
	BCF	CCP1CON,CCP1Y
	BTFSC	STATUS,C
	BSF	CCP1CON,CCP1Y
	RRF	ZVUK,W
	BCF	CCP1CON,CCP1X
	BTFSC	STATUS,C
	BSF	CCP1CON,CCP1X
	ANDLW	B'00111111'
	MOVWF	CCPR1L
	
	GENER	D'0'
	GENER	(PERIOD2 - PERIOD1)
	GENER	(PERIOD3 - PERIOD1)
	GENER	(PERIOD4 - PERIOD1)

	MOVF	ZVUK1,W
	CALL	AMPLITUDA
	MOVWF	ZVUK
	MOVF	ZVUK2,W
	CALL	AMPLITUDA
	ADDWF	ZVUK,F
	MOVLW	D'255'
	BTFSC	STATUS,C
	MOVWF	ZVUK
	MOVF	ZVUK3,W
	CALL	AMPLITUDA
	ADDWF	ZVUK,F
	MOVLW	D'255'
	BTFSC	STATUS,C
	MOVWF	ZVUK
	MOVF	ZVUK4,W
	CALL	AMPLITUDA
	ADDWF	ZVUK,F
	MOVLW	D'255'
	BTFSC	STATUS,C
	MOVWF	ZVUK

INT_END2	MOVF	ST_TEMP2,W
	MOVWF	STATUS
	SWAPF	W_TEMP2,F
	SWAPF	W_TEMP2,W
	RETFIE
;-----------------------------------------------

PLAYCODE	BCF	DELAY+2,0
	CTI_CAS
	MOVF	TEMP+1,W
	IORWF	TEMP+0,W
	BTFSS	STATUS,Z
	GOTO	$ + 3
	BCF	PLAY,0
	GOTO	LABELX
	BCF	INTCON,GIE
	BTFSC	INTCON,GIE
	GOTO	$ - 2
	MOVF	TEMP+0,W
	MOVWF	DELAY+0
	MOVF	TEMP+1,W
	MOVWF	DELAY+1
	BSF	INTCON,GIE

	MOVLW	ZSTATUS1
	MOVWF	FSR
	MOVLW	D'4'
	MOVWF	GCITAC
GCITANI
	SETGEN
	MOVLW	ZSTATUS2-ZSTATUS1
	ADDWF	FSR
	RRF	NEAKTIV,F
	RRF	AKTIV,F
	DECFSZ	GCITAC,F
	GOTO	GCITANI
	GOTO	LABELX

;-----------------------------------------------
;-----------------------------------------------

START	CLRF	PORTD
	banksel	TRISD
	MOVLW	B'00001111'
	MOVWF	TRISD
	banksel	T1CON
	MOVLW	B'00001101'
	MOVWF	T1CON
	MOVLW	B'00011100'
	MOVWF	T2CON
	BSF	STATUS,RP0
	MOVLW	D'63'
	MOVWF	PR2
	MOVLW	B'10000100'
	MOVWF	ADCON1
	MOVLW	B'00000000'
	MOVWF	OPTION_REG
	BCF	STATUS,RP0
	MOVLW	B'10000001'
	MOVWF	ADCON0

	CLRF	TMR2
	CLRF	CCPR1L
	MOVLW	B'00001100'
	MOVWF	CCP1CON

	BSF	STATUS,RP0
	BCF	DB4
	BCF	DB5
	BCF	DB6
	BCF	DB7
	BCF	E
	BCF	RS
	BCF	RW
	BCF	TRISC,2
	BCF	STATUS,RP0

	CLRF	INTVER
	CLRF	PLAY

	CALL	INITDISP

	MOVLW	D'1'
	CALL	SKRIPT

	CLRF	ZVUK1
	CLRF	ZVUK2
	CLRF	ZVUK3
	CLRF	ZVUK4
	CLRF	AMPLIT1+1
	CLRF	AMPLIT2+1
	CLRF	AMPLIT3+1
	CLRF	AMPLIT4+1
	BCF	ZSTATUS1,AKTIVNI
	BCF	ZSTATUS2,AKTIVNI
	BCF	ZSTATUS3,AKTIVNI
	BCF	ZSTATUS4,AKTIVNI

	banksel	PIE1
	BSF	PIE1,TMR2IE
	banksel	0
	BSF	INTCON,PEIE
	BSF	INTCON,GIE

	MOVLW	D'0'
	TABFIND	HUDBY
	banksel	EEADR
	MOVF	EEADR,W
	MOVWF	EEADRY
	MOVF	EEADRH,W
	MOVWF	EEADRHY
	banksel	0
	BSF	DELAY+2,0
	BSF	PLAY,0

LOOP	SWAPF	AMPLIT1+1,W
	ANDLW	B'00001111'
	MOVWF	HH1
	SWAPF	AMPLIT2+1,W
	ANDLW	B'00001111'
	MOVWF	HH2
	SWAPF	AMPLIT3+1,W
	ANDLW	B'00001111'
	MOVWF	HH3
	SWAPF	AMPLIT4+1,W
	ANDLW	B'00001111'
	MOVWF	HH4

	MOVLW	D'0'
	CALL	SETPOS
	MOVLW	'1'
	CALL	PUTZNAK
	MOVF	HH1,W
	ADDLW	NULSLOUP-TABULKY
	CALL	SKRIPT
	MOVLW	'2'
	CALL	PUTZNAK
	MOVF	HH2,W
	ADDLW	NULSLOUP-TABULKY
	CALL	SKRIPT
	MOVLW	D'64'
	CALL	SETPOS
	MOVLW	'3'
	CALL	PUTZNAK
	MOVF	HH3,W
	ADDLW	NULSLOUP-TABULKY
	CALL	SKRIPT
	MOVLW	'4'
	CALL	PUTZNAK
	MOVF	HH4,W
	ADDLW	NULSLOUP-TABULKY
	CALL	SKRIPT
	
	BTFSS	KLAVESA1
	GOTO	LOOP2
	GOTO	LOOP

LOOP2	
	banksel	POLE
	INCF	PCITAC,W
	ANDLW	B'00111111'
	MOVWF	PCITAC
	
	CLRF	POLE+0
	CLRF	POLE+1
	CLRF	POLE+2
	CLRF	POLE+3
	CLRF	POLE+4
	CLRF	POLE+5
	CLRF	POLE+6
	CLRF	POLE+7

	banksel	TON1
	BTFSS	ZSTATUS1,AKTIVNI
	GOTO	DALSI1
	MOVF	TON1,W
	banksel	PCOUNT
	include	efekt.inc
DALSI1
	banksel	TON2
	BTFSS	ZSTATUS2,AKTIVNI
	GOTO	DALSI2
	MOVF	TON2,W
	banksel	PCOUNT
	include	efekt.inc
DALSI2
	banksel	TON3
	BTFSS	ZSTATUS3,AKTIVNI
	GOTO	DALSI3
	MOVF	TON3,W
	banksel	PCOUNT
	include	efekt.inc
DALSI3
	banksel	TON4
	BTFSS	ZSTATUS4,AKTIVNI
	GOTO	DALSI4
	MOVF	TON4,W
	banksel	PCOUNT
	include	efekt.inc
DALSI4
	banksel	0
	MOVLW	D'0'
	CALL	SETPOS
	banksel	POLE
	MOVLW	D'16'
	MOVWF	PCOUNT
LOOP2A	RLF	POLE+4,F
	RLF	POLE+5,F
	RLF	POLE+6,F
	RLF	POLE+7,F
	RLF	PTEMP,F
	RLF	POLE+4,F
	RLF	POLE+5,F
	RLF	POLE+6,F
	RLF	POLE+7,F
	RLF	PTEMP,W
	ANDLW	B'00000011'
	banksel	0
	CALL	PUTZNAK
	banksel	POLE
	DECFSZ	PCOUNT,F
	GOTO	LOOP2A

	banksel	0
	MOVLW	D'64'
	CALL	SETPOS
	banksel	POLE
	MOVLW	D'16'
	MOVWF	PCOUNT
LOOP2B	RLF	POLE+0,F
	RLF	POLE+1,F
	RLF	POLE+2,F
	RLF	POLE+3,F
	RLF	PTEMP,F
	RLF	POLE+0,F
	RLF	POLE+1,F
	RLF	POLE+2,F
	RLF	POLE+3,F
	RLF	PTEMP,W
	ANDLW	B'00000011'
	banksel	0
	CALL	PUTZNAK
	banksel	POLE
	DECFSZ	PCOUNT,F
	GOTO	LOOP2B

	banksel	0
	BTFSS	KLAVESA2
	GOTO	LOOP
	GOTO	LOOP2

;----------------------------------------------------------

	; deleni
DIV16U	DIV16U_M	AA,BB,CC,VD16U 

	; skripty
SKRIPT	SKRIPT_	TABULKY, PUTZNAK, DPRIKAZ, NUMFORM_, DIV16U, AA, BB, CC
	RETURN

	; obsluha displeje
	DISPLEJ	TMH,TML,DDATA,DB4,DB5,DB6,DB7,E,RW,RS

;-----------------------------------------------------------

AMPLITUDA	MOVWF	WTABTEMP
	MOVLW	AMPLDATA / H'100'
	MOVWF	PCLATH
	MOVLW	AMPLDATA % H'100'
	ADDWF	WTABTEMP,W
	BTFSC	STATUS,C
	INCF	PCLATH,F
	MOVWF	PCL

;---------------------------------------
; amplitudy dozvuku
AMPLDATA
	include	ampldata.inc

;---------------------------------------
; periody vybranych tonu
TONY	
	include	tony.inc

;---------------------------------------
; delky not (respektive casovani znacek)
CASY
	include	casy.inc

;---------------------------------------
; preddefinovane delky dozvuku
DOZVUKY
	include	dozvuky.inc

;---------------------------------------
; preddefinovane hlasitosti
HLASITOST	
	include	hlasit.inc

;---------------------------------------
; zobrazovaci data:

TABULKY	DATA	UVOD
	DATA	SLOUPCE
NULSLOUP	DATA	STAV0
	DATA	STAV1
	DATA	STAV2
	DATA	STAV3
	DATA	STAV4
	DATA	STAV5
	DATA	STAV6
	DATA	STAV7
	DATA	STAV8
	DATA	STAV9
	DATA	STAV10
	DATA	STAV11
	DATA	STAV12
	DATA	STAV13
	DATA	STAV14
	DATA	STAV15

UVOD	POS_D	D'0'
	DE	"G1: "
	PRINTV	HH1,B'00111',0,0,1,1
	DE	"  "
	DE	"G2: "
	PRINTV	HH2,B'00111',0,0,1,1
	DE	"      "
	POS_D	D'64'
	DE	"G3: "
	PRINTV	HH3,B'00111',0,0,1,1
	DE	"  "
	DE	"G4: "
	PRINTV	HH4,B'00111',0,0,1,1
	DE	"      "
	EOFS
SLOUPCE	POS_SG	D'0'
	DE	B'00000'
	DE	B'00000'
	DE	B'00000'
	DE	B'00000'
	DE	B'00000'
	DE	B'00000'
	DE	B'11011'
	DE	B'00000'
	DE	B'00000'
	DE	B'00011'
	DE	B'00011'
	DE	B'00011'
	DE	B'00011'
	DE	B'00011'
	DE	B'11011'
	DE	B'00000'
	DE	B'00000'
	DE	B'11000'
	DE	B'11000'
	DE	B'11000'
	DE	B'11000'
	DE	B'11000'
	DE	B'11011'
	DE	B'00000'
	DE	B'00000'
	DE	B'11011'
	DE	B'11011'
	DE	B'11011'
	DE	B'11011'
	DE	B'11011'
	DE	B'11011'
	DE	B'00000'
	DE	B'00000'
	DE	B'11000'
	DE	B'11000'
	DE	B'11000'
	DE	B'11000'
	DE	B'11000'
	DE	B'11000'
	DE	B'00000'
	EOFS
STAV0	DBLOK	' ',7
	EOFS
STAV1	DE	D'4'
	DBLOK	' ',6
	EOFS
STAV2	DBLOK	D'3',1
	DBLOK	' ',6
	EOFS
STAV3	DBLOK	D'3',1
	DE	D'4'
	DBLOK	' ',5
	EOFS
STAV4	DBLOK	D'3',2
	DBLOK	' ',5
	EOFS
STAV5	DBLOK	D'3',2
	DE	D'4'
	DBLOK	' ',4
	EOFS
STAV6	DBLOK	D'3',3
	DBLOK	' ',4
	EOFS
STAV7	DBLOK	D'3',3
	DE	D'4'
	DBLOK	' ',3
	EOFS
STAV8	DBLOK	D'3',4
	DBLOK	' ',3
	EOFS
STAV9	DBLOK	D'3',4
	DE	D'4'
	DBLOK	' ',2
	EOFS
STAV10	DBLOK	D'3',5
	DBLOK	' ',2
	EOFS
STAV11	DBLOK	D'3',5
	DE	D'4'
	DBLOK	' ',1
	EOFS
STAV12	DBLOK	D'3',6
	DBLOK	' ',1
	EOFS
STAV13	DBLOK	D'3',6
	DE	D'4'
	EOFS
STAV14	DBLOK	D'3',7
	EOFS
STAV15	DBLOK	D'3',7
	EOFS

;--------------------------------------
; SKLADBY
HUDBY	DATA	MOZART

MOZART	
	include	mozart.inc	

	END
